diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_nodes_steps.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_nodes_steps.py
new file mode 100644
index 000000000..a3acbe353
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_nodes_steps.py
@@ -0,0 +1,75 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
+
+
+class PgAgentGetNodesStepTestCase(BaseTestGenerator):
+    """This class will fetch pgAgent job step nodes"""
+    scenarios = utils.generate_scenarios("pgagent_get_nodes_step",
+                                         steps_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get_nodes%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        step_name = "test_step_get_nodes%s" % str(uuid.uuid4())[1:8]
+        self.step_id = pgagent_utils.create_pgagent_step(
+            self, step_name, self.job_id)
+
+        if self.is_list:
+            step_name_2 = "test_step_get_nodes%s" % str(uuid.uuid4())[1:8]
+            self.step_id_2 = pgagent_utils.create_pgagent_step(
+                self, step_name_2, self.job_id)
+
+    def runTest(self):
+        """This function will fetch pgAgent job nodes"""
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.step_id, self.step_id_2]
+                response = steps_utils.api_get(self, '')
+            else:
+                response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = steps_utils.api_get(self)
+            else:
+                if "step_id" in self.data:
+                    self.step_id = self.data["step_id"]
+                response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps.py
new file mode 100644
index 000000000..9ce1f3622
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps.py
@@ -0,0 +1,75 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
+
+
+class PgAgentGetStepTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job step API"""
+    scenarios = utils.generate_scenarios("pgagent_get_step",
+                                         steps_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        step_name = "test_step_get%s" % str(uuid.uuid4())[1:8]
+        self.step_id = pgagent_utils.create_pgagent_step(
+            self, step_name, self.job_id)
+
+        if self.is_list:
+            step_name_2 = "test_step_get%s" % str(uuid.uuid4())[1:8]
+            self.step_id_2 = pgagent_utils.create_pgagent_step(
+                self, step_name_2, self.job_id)
+
+    def runTest(self):
+        """This function will get pgAgent job step"""
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.step_id, self.step_id_2]
+                response = steps_utils.api_get(self, '')
+            else:
+                response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = steps_utils.api_get(self)
+            else:
+                if "step_id" in self.data:
+                    self.step_id = self.data["step_id"]
+                response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps_stats.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps_stats.py
new file mode 100644
index 000000000..23714463d
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_get_steps_stats.py
@@ -0,0 +1,62 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
+
+
+class PgAgentGetStepTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job step stats"""
+    scenarios = utils.generate_scenarios("pgagent_get_step_stats",
+                                         steps_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get_stats%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        step_name = "test_step_get_stats%s" % str(uuid.uuid4())[1:8]
+        self.step_id = pgagent_utils.create_pgagent_step(
+            self, step_name, self.job_id)
+
+    def runTest(self):
+        """This function will get pgAgent job step stats"""
+        if self.is_positive_test:
+            response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = steps_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_put_step.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_put_steps.py
similarity index 56%
rename from web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_put_step.py
rename to web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_put_steps.py
index 09921af93..aa178618e 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_put_step.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_put_steps.py
@@ -6,33 +6,21 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+from unittest.mock import patch
 
 import simplejson as json
 import uuid
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
-from . import utils as pgagent_utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
 
 
 class PgAgentPutStepTestCase(BaseTestGenerator):
     """This class will test the update pgAgent steps API"""
-    scenarios = [
-        ('Update step with kind, description, code and error', dict(
-            url='/browser/pga_jobstep/obj/',
-            data={
-                'jstdesc': 'Test Steps',
-                'jstkind': False,
-                'jstcode': 'SELECT 12345',
-                'jstonerror': 'i'
-            })),
-        ('Update step with connection type and string', dict(
-            url='/browser/pga_jobstep/obj/',
-            data={
-                'jstconntype': False,
-                'jstconnstr':
-                    'host=localhost port=5432 dbname=mydb connect_timeout=10'
-            }))
-    ]
+    scenarios = utils.generate_scenarios("pgagent_put_step",
+                                         steps_utils.test_cases)
 
     def setUp(self):
         flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
@@ -41,25 +29,38 @@ class PgAgentPutStepTestCase(BaseTestGenerator):
         flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
         if not flag:
             self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
         name = "test_job_update%s" % str(uuid.uuid4())[1:8]
         self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
         step_name = "test_step_update%s" % str(uuid.uuid4())[1:8]
         self.step_id = pgagent_utils.create_pgagent_step(
             self, step_name, self.job_id)
 
     def runTest(self):
         """This function will update pgAgent steps"""
-
         self.data['jstid'] = str(self.step_id)
-        response = self.tester.put(
-            '{0}{1}/{2}/{3}/{4}'.format(
-                self.url, str(utils.SERVER_GROUP), str(self.server_id),
-                str(self.job_id), str(self.step_id)
-            ),
-            data=json.dumps(self.data),
-            content_type='html/json'
-        )
-        self.assertEqual(response.status_code, 200)
+
+        if self.is_positive_test:
+            response = steps_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = steps_utils.api_put(self)
+            else:
+                if "step_id" in self.data:
+                    self.step_id = self.data["step_id"]
+                response = steps_utils.api_put(self)
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
 
     def tearDown(self):
         """Clean up code"""
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/utils.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/utils.py
new file mode 100644
index 000000000..60737baef
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/utils.py
@@ -0,0 +1,59 @@
+import os
+import json
+from urllib.parse import urlencode
+
+from regression.python_test_utils import test_utils as utils
+
+# Load test data from json file.
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/steps_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+# api methods
+def api_create(self):
+    return self.tester.post('{0}{1}/{2}/{3}/'.
+                            format(self.url, utils.SERVER_GROUP,
+                                   self.server_id, self.job_id),
+                            data=json.dumps(self.data),
+                            content_type='html/json')
+
+
+def api_delete(self, step_id=None):
+    if step_id is None:
+        step_id = self.step_id
+    return self.tester.delete('{0}{1}/{2}/{3}/{4}'.
+                              format(self.url, utils.SERVER_GROUP,
+                                     self.server_id, self.job_id, step_id),
+                              data=json.dumps(self.data),
+                              content_type='html/json')
+
+
+def api_put(self):
+    return self.tester.put('{0}{1}/{2}/{3}/{4}'.
+                           format(self.url, utils.SERVER_GROUP, self.server_id,
+                                  self.job_id, self.step_id),
+                           data=json.dumps(self.data),
+                           content_type='html/json')
+
+
+def api_get(self, step_id=None):
+    if step_id is None:
+        step_id = self.step_id
+    return self.tester.get('{0}{1}/{2}/{3}/{4}'.
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id,
+                                  step_id),
+                           content_type='html/json')
+
+
+def api_get_msql(self, url_encode_data, step_id=None):
+    if step_id is None:
+        step_id = '/' + str(self.step_id)
+    return self.tester.get("{0}{1}/{2}/{3}{4}?{5}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id,
+                                  step_id,
+                                  urlencode(url_encode_data)),
+                           data=json.dumps(self.data),
+                           follow_redirects=True)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_add.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_add.py
new file mode 100644
index 000000000..acbb4f970
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_add.py
@@ -0,0 +1,74 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+from unittest.mock import patch
+
+import simplejson as json
+import uuid
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentAddTestCase(BaseTestGenerator):
+    """This class will test the add pgAgent job API"""
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("pgagent_job_create",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        # Load test data
+        self.data = self.test_data
+
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+    def runTest(self):
+        """This function will adds pgAgent job"""
+        self.pgagent_job = "test_job_add%s" % str(uuid.uuid4())[1:8]
+
+        if "jobname" in self.data:
+            self.data["jobname"] = self.pgagent_job
+
+        if self.is_positive_test:
+            response = pgagent_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+            # Verify in backend
+            response_data = json.loads(response.data)
+            self.job_id = response_data['node']['_id']
+            is_present = pgagent_utils.verify_pgagent_job(self)
+            self.assertTrue(is_present,
+                            "pgAgent job was not created successfully")
+
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = pgagent_utils.api_create(self)
+
+                    # Assert response
+                    utils.assert_status_code(self, response)
+                    utils.assert_error_message(self, response)
+            else:
+                response = pgagent_utils.api_create(self)
+
+                # Assert response
+                utils.assert_status_code(self, response)
+                utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        if self.is_positive_test:
+            pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_delete.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_delete.py
similarity index 61%
rename from web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_delete.py
rename to web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_delete.py
index 53a564479..c636208c8 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_delete.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_delete.py
@@ -15,9 +15,9 @@ from . import utils as pgagent_utils
 
 class PgAgentDeleteTestCase(BaseTestGenerator):
     """This class will test the delete pgAgent job API"""
-    scenarios = [
-        ('Delete pgAgent job', dict(url='/browser/pga_job/obj/'))
-    ]
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("pgagent_job_delete",
+                                         pgagent_utils.test_cases)
 
     def setUp(self):
         flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
@@ -26,24 +26,35 @@ class PgAgentDeleteTestCase(BaseTestGenerator):
         flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
         if not flag:
             self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
         name = "test_job_delete%s" % str(uuid.uuid4())[1:8]
         self.job_id = pgagent_utils.create_pgagent_job(self, name)
 
+        if self.is_list:
+            name2 = "test_job2_delete%s" % str(uuid.uuid4())[1:8]
+            self.job_id2 = pgagent_utils.create_pgagent_job(self, name2)
+
     def runTest(self):
         """This function will deletes pgAgent job"""
-        response = self.tester.delete(
-            '{0}{1}/{2}/{3}'.format(
-                self.url, str(utils.SERVER_GROUP), str(self.server_id),
-                str(self.job_id)
-            ),
-            content_type='html/json'
-        )
-        self.assertEqual(response.status_code, 200)
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.job_id, self.job_id2]
+                response = pgagent_utils.api_delete(self, '')
+            else:
+                response = pgagent_utils.api_delete(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
         is_present = pgagent_utils.verify_pgagent_job(self)
         self.assertFalse(
-            is_present, "pgAgent job was not deleted successfully"
-        )
+            is_present, "pgAgent job was not deleted successfully")
 
     def tearDown(self):
         """Clean up code"""
         pgagent_utils.delete_pgagent_job(self)
+        if self.is_list:
+            pgagent_utils.delete_pgagent_job(self, self.job_id2)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get.py
new file mode 100644
index 000000000..8d7bde072
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get.py
@@ -0,0 +1,73 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentGetTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job API"""
+    scenarios = utils.generate_scenarios("pgagent_job_get",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        # In case of multiple views
+        if self.is_list:
+            name_2 = "test_job_get%s" % str(uuid.uuid4())[1:8]
+            self.job_id_2 = pgagent_utils.create_pgagent_job(self, name_2)
+
+    def runTest(self):
+        """This function will get pgAgent job"""
+
+        if self.is_positive_test:
+            if self.is_list:
+                response = pgagent_utils.api_get(self, '')
+            else:
+                response = pgagent_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_get(self)
+            elif 'job_id' in self.data:
+                # Non-existing job id
+                existing_job_id = self.job_id
+                self.job_id = self.data["job_id"]
+                response = pgagent_utils.api_get(self)
+                self.job_id = existing_job_id
+
+                # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
+        if self.is_list:
+            pgagent_utils.delete_pgagent_job(self, self.job_id_2)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_stats.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_msql.py
similarity index 54%
rename from web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_stats.py
rename to web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_msql.py
index 91a2a2175..0d6392a9a 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_stats.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_msql.py
@@ -6,18 +6,20 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+from unittest.mock import patch
 
+import simplejson as json
 import uuid
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
 from . import utils as pgagent_utils
 
 
-class PgAgentStatsTestCase(BaseTestGenerator):
-    """This class will test the stats pgAgent job API"""
-    scenarios = [
-        ('Check the stats of pgAgent job', dict(url='/browser/pga_job/stats/'))
-    ]
+class PgAgentGetMsqlTestCase(BaseTestGenerator):
+    """This class will test the put pgAgent job API"""
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("pgagent_job_msql",
+                                         pgagent_utils.test_cases)
 
     def setUp(self):
         flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
@@ -26,19 +28,24 @@ class PgAgentStatsTestCase(BaseTestGenerator):
         flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
         if not flag:
             self.skipTest(msg)
-        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_msql%s" % str(uuid.uuid4())[1:8]
         self.job_id = pgagent_utils.create_pgagent_job(self, name)
 
     def runTest(self):
-        """This function will check stats of pgAgent job"""
-        response = self.tester.get(
-            '{0}{1}/{2}/{3}'.format(
-                self.url, str(utils.SERVER_GROUP), str(self.server_id),
-                str(self.job_id)
-            ),
-            content_type='html/json'
-        )
-        self.assertEqual(response.status_code, 200)
+        """This function will get msql for pgAgent job"""
+
+        if self.is_positive_test:
+            url_encode_data = self.data
+            url_encode_data["jobid"] = self.job_id
+
+            response = pgagent_utils.api_get_msql(self, url_encode_data)
+
+            # Assert response
+            utils.assert_status_code(self, response)
 
     def tearDown(self):
         """Clean up code"""
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_nodes.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_nodes.py
new file mode 100644
index 000000000..58e26f69e
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_nodes.py
@@ -0,0 +1,73 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentGetNodesTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job nodes API"""
+    scenarios = utils.generate_scenarios("pgagent_job_get_nodes",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get_nodes%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        # In case of multiple views
+        if self.is_list:
+            name_2 = "test_job_get_nodes%s" % str(uuid.uuid4())[1:8]
+            self.job_id_2 = pgagent_utils.create_pgagent_job(self, name_2)
+
+    def runTest(self):
+        """This function will get pgAgent job nodes"""
+
+        if self.is_positive_test:
+            if self.is_list:
+                response = pgagent_utils.api_get(self, '')
+            else:
+                response = pgagent_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_get(self)
+            elif 'job_id' in self.data:
+                # Non-existing job id
+                existing_job_id = self.job_id
+                self.job_id = self.data["job_id"]
+                response = pgagent_utils.api_get(self)
+                self.job_id = existing_job_id
+
+                # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
+        if self.is_list:
+            pgagent_utils.delete_pgagent_job(self, self.job_id_2)
